<?php
/*
Plugin Name: Count Posts in a Category
Plugin URI: http://shinraholdings.com/plugins/count-posts-in-a-category
Description: Adds a custom short code that returns the number of posts in a given category.
Version: 2.1
Author: bitacre
Author URI: http://shinraholdings.com
License: GPLv2 
	Copyright 2012 Shinra Web Holdings (plugins@shinraholdings.com)
Usage: 
	[catcountposts cat="category-slug"]
	[catcountposts tag="tag-slug"]
	[catcountposts type="id" cat="21"]
	[catcountposts type="name" cat="Category Name"]
	Shortcodes: catcountposts, countposts, countpost, postsincat, postincat, ccp
*/

function cat_count_posts( $atts ) {
	extract( shortcode_atts( array( // extract arguments
		'cat' => NULL, 
		'tag' => NULL,
		'type' => NULL,
	), $atts ) ); 
	
	// determine type
	if( $type == 'name' ) $utype = 'name'; // category name
	elseif( $type == 'id' ) $utype = 'cat_ID'; // category ID number
	else $utype = 'slug'; // otherwise assume slug

	if( !empty( $cat ) ) {
		$categories = get_categories(); // load all categories into array
		foreach( $categories as $category ) 
			if( $category->$utype == $cat ) return $category->count; // return count on match
	}
	
	elseif( !empty( $tag ) ) {
		$tagies = get_tags(); // load all categories into array
		foreach( $tagies as $tagie ) 
			if( $tagie->$utype == $tag ) return $tagie->count; // return count on match

	}
	
	else {
		return 0; // else return 0
	}
}

$shortcodes = array( // list of shortcodes
	'catcountposts', 
	'countposts', 
	'countpost', 
	'postsincat', 
	'postincat', 
	'ccp' );
foreach( $shortcodes as $shortcode ) add_shortcode( $shortcode, 'cat_count_posts' );
?>